module NetzplanMicroFrontend
  module Generators
    class InstallAssetStructureGenerator < ::Rails::Generators::Base
      source_root File.expand_path('templates', __dir__)

      def create_javascript
        create_file "app/javascript/templates/.keep"
        create_file "app/javascript/micro_frontend_management/.keep"

        copy_file "index_mapbox_styles.coffee", "app/javascript/mapbox_styles/index.coffee"
        copy_file "index_models.js", "app/javascript/models/index.js"
        copy_file "index_views.coffee", "app/javascript/views/index.coffee"

        copy_file "pack.coffee", "app/javascript/packs/micro_frontend.coffee"

      end

      def create_stylesheets
        create_file "app/assets/stylesheets/info_window/.keep"

        copy_file "manifest.css", "app/assets/stylesheets/micro_frontend.css"
      end
    end
  end
end
