module NetzplanMicroFrontend
  module Generators
    class InstallFileTypesGenerator < ::Rails::Generators::Base
      source_root File.expand_path('templates', __dir__)

      def add_yarn_dependencies
        inject_into_file 'package.json', after: "  \"dependencies\": {\n" do
<<-'JAVASCRIPT'
    "coffee-loader": "^0.9.0",
    "coffeescript": "1.12.7",
    "ejs-webpack-loader": "^2.2.2",
    "backbone": "^1.4.0",
    "jquery": "^3.4.1",
JAVASCRIPT
        end
      end

      def install_ejs
        copy_file "ejs_loader.js", "config/webpack/loaders/ejs.js"

        inject_into_file 'config/webpack/environment.js', after: "const { environment } = require('@rails/webpacker')\n" do
<<-'JAVASCRIPT'
const ejs = require('./loaders/ejs')
environment.loaders.prepend('ejs', ejs)

JAVASCRIPT
        end
      end

      def install_coffeescript
        copy_file "coffee_loader.js", "config/webpack/loaders/coffee.js"
        inject_into_file 'config/webpacker.yml', after: "  extensions:\n" do
<<-'YAML'
    - .coffee
YAML
        end

        inject_into_file 'config/webpack/environment.js', after: "const { environment } = require('@rails/webpacker')\n" do
<<-'JAVASCRIPT'
const coffee = require('./loaders/coffee')
environment.loaders.prepend('coffee', coffee)

JAVASCRIPT
        end
      end
    end
  end
end
